﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Sudoku
{
    public partial class AlgorithmSettings : Form
    {
        AlgorithmManager Manager;

        public AlgorithmSettings(AlgorithmManager manager)
        {
            InitializeComponent();
            this.Manager = manager;
            chbNakedSingle.Checked = manager.GetAlgorithmState(0);
            chbHiddenSingle.Checked = manager.GetAlgorithmState(1);
            chbIntersection.Checked = manager.GetAlgorithmState(2);
            chbNakedPairs.Checked = manager.GetAlgorithmState(3);
            chbNakedTriple.Checked = manager.GetAlgorithmState(4);
            chbHiddenPair.Checked = manager.GetAlgorithmState(5);
            chbHiddenTriple.Checked = manager.GetAlgorithmState(6);
            chbHiddenQuad.Checked = manager.GetAlgorithmState(7);
            chbNakedQuad.Checked = manager.GetAlgorithmState(8);

            switch (manager.AdvancedAlgorithm)
            { 
                case AdvancedAlgorithms.Nishio:
                    rbNishio.Checked = true;
                    break;
                case AdvancedAlgorithms.Crook:
                    rbCrook.Checked = true;
                    break;
                case AdvancedAlgorithms.DancingLinks:
                    rbDancingLinks.Checked = true;
                    break;
                case AdvancedAlgorithms.Off:
                    rbOff.Checked = true;
                    break;
            }
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            this.Hide();
            this.Dispose();
        }

        private void chbNakedSingle_CheckedChanged(object sender, EventArgs e)
        {
            Manager.SetAlgorithmState(0, chbNakedSingle.Checked);
        }

        private void chbHiddenSingle_CheckedChanged(object sender, EventArgs e)
        {
            Manager.SetAlgorithmState(1, chbHiddenSingle.Checked);
        }

        private void chbIntersection_CheckedChanged(object sender, EventArgs e)
        {
            Manager.SetAlgorithmState(2, chbIntersection.Checked);
        }

        private void chbNakedPairs_CheckedChanged(object sender, EventArgs e)
        {
            Manager.SetAlgorithmState(3, chbNakedPairs.Checked);
        }

        private void chbHiddenPair_CheckedChanged(object sender, EventArgs e)
        {
           Manager.SetAlgorithmState(4, chbHiddenPair.Checked);
        }

        private void chbNakedTriple_CheckedChanged(object sender, EventArgs e)
        {
            Manager.SetAlgorithmState(5, chbNakedTriple.Checked);
        }

        private void chbHiddenTriple_CheckedChanged(object sender, EventArgs e)
        {
            Manager.SetAlgorithmState(6, chbHiddenTriple.Checked);
        }

        private void chbHiddenQuad_CheckedChanged(object sender, EventArgs e)
        {
            Manager.SetAlgorithmState(7, chbHiddenQuad.Checked);
        }

        private void chbNakedQuad_CheckedChanged(object sender, EventArgs e)
        {
            Manager.SetAlgorithmState(8, chbNakedQuad.Checked);
        }

        private void rbNishio_CheckedChanged(object sender, EventArgs e)
        {
            Manager.AdvancedAlgorithm = AdvancedAlgorithms.Nishio;
        }

        private void rbCrook_CheckedChanged(object sender, EventArgs e)
        {
            Manager.AdvancedAlgorithm = AdvancedAlgorithms.Crook;
        }

        private void rbDancingLinks_CheckedChanged(object sender, EventArgs e)
        {
            Manager.AdvancedAlgorithm = AdvancedAlgorithms.DancingLinks;
        }

        private void rbOff_CheckedChanged(object sender, EventArgs e)
        {
            Manager.AdvancedAlgorithm = AdvancedAlgorithms.Off;
        }
    }
}
