﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Sudoku
{
    class HiddenPair : Algorithm
    {
        public HiddenPair()
        {
            name = "Hidden Pair";
        }

        string globmessage = string.Empty;

        public override string TestCell(SudokuTable table, IntPair redCell, IntPair greenCell, int redCand, int greenCand)
        {
            if (!Enabled) return "";

            t = table;
            SearchHiddenPairInRow(redCell.i, redCell.j);
            SearchHiddenPairInColumn(redCell.i, redCell.j);
            SearchHiddenPairInBox(redCell.i / t.N, redCell.j / t.N, redCell.i, redCell.j);

            return "";
        }

        private void SearchHiddenPairInRow(int row, int col)
        {
            //vegig a sorokon
            int[] candidate_numbers = new int[t.M + 1];
            IntPair[][] candidate_positions = new IntPair[t.M + 1][];
            for (int k = 0; k <= t.M; ++k)
            {
                candidate_positions[k] = new IntPair[2];
            }

            //vegig a sorok cellain
            for (int j = 0; j < t.M; ++j)
            {
                if (!t.Cells[row, j].IsData())
                {
                    for (int c = 1; c <= t.M; ++c)
                    {
                        if (t.Cells[row, j].IsCandidate(c))
                        {
                            if (candidate_numbers[c] < 2)
                            {
                                candidate_positions[c][candidate_numbers[c]] = new IntPair(row, j);
                            }
                            ++candidate_numbers[c];
                        }
                    }
                }
            }

            for (int c1 = 1; c1 < t.M; ++c1)
            {
                for (int c2 = c1 + 1; c2 <= t.M; ++c2)
                {
                    if (candidate_numbers[c1] == 2 && candidate_numbers[c2] == 2 && 
                        IntPair.Equals(candidate_positions[c1][0], candidate_positions[c2][0]) &&
                        IntPair.Equals(candidate_positions[c1][1], candidate_positions[c2][1]) &&
                        (t.Cells[candidate_positions[c1][0].i, candidate_positions[c1][0].j].CandidatesNumber > 2 ||
                        t.Cells[candidate_positions[c1][1].i, candidate_positions[c1][1].j].CandidatesNumber > 2) &&
                        !IntPair.Equals(candidate_positions[c1][0], new IntPair(row, col)) &&
                        !IntPair.Equals(candidate_positions[c1][1], new IntPair(row, col)))
                    {
                        List<IntPair> rcc = new List<IntPair>();
                        List<int> rc = new List<int>();
                        List<IntPair> gcc = new List<IntPair>();
                        List<int> gc = new List<int>();

                        //a mintaban szereplo jeloltek megkesesese
                        for (int c = 1; c <= t.M; ++c)
                        {
                            if (c == c1 || c == c2)
                            {
                                gcc.Add(candidate_positions[c1][0]);
                                gc.Add(c);
                            }
                            else if (t.Cells[candidate_positions[c1][0].i, candidate_positions[c1][0].j].IsCandidate(c))
                            {
                                rcc.Add(candidate_positions[c1][0]);
                                rc.Add(c);
                            }

                            if (c == c1 || c == c2)
                            {
                                gcc.Add(candidate_positions[c2][1]);
                                gc.Add(c);
                            }
                            else if (t.Cells[candidate_positions[c1][1].i, candidate_positions[c1][1].j].IsCandidate(c))
                            {
                                rcc.Add(candidate_positions[c1][1]);
                                rc.Add(c);
                            }
                        }



                        HiddenPairPattern p = new HiddenPairPattern(0, gc, gcc, rc, rcc);
                        p.HouseType = RectangleTypes.Row;
                        if (AlgorithmManager.Instance.SolveState == SolveStates.RozsaSolve)
                        {
                            AlgorithmManager.Instance.ApplyPattern(p);
                        }
                        else
                        {
                            AlgorithmManager.Instance.AddPattern(p);
                        }
                    }
                }
            }
        }

        private void SearchHiddenPairInColumn(int row, int col)
        {
            int[] candidate_numbers = new int[t.M + 1];
            IntPair[][] candidate_positions = new IntPair[t.M + 1][];
            for (int k = 0; k <= t.M; ++k)
            {
                candidate_positions[k] = new IntPair[2];
            }

            //vegig a sorok cellain
            for (int i = 0; i < t.M; ++i)
            {
                if (!t.Cells[i, col].IsData())
                {
                    for (int c = 1; c <= t.M; ++c)
                    {
                        if (t.Cells[i, col].IsCandidate(c))
                        {
                            if (candidate_numbers[c] < 2)
                            {
                                candidate_positions[c][candidate_numbers[c]] = new IntPair(i, col);
                            }
                            ++candidate_numbers[c];
                        }
                    }
                }
            }

            for (int c1 = 1; c1 < t.M; ++c1)
            {
                for (int c2 = c1 + 1; c2 <= t.M; ++c2)
                {
                    if (candidate_numbers[c1] == 2 && candidate_numbers[c2] == 2 &&
                        IntPair.Equals(candidate_positions[c1][0], candidate_positions[c2][0]) &&
                        IntPair.Equals(candidate_positions[c1][1], candidate_positions[c2][1]) &&
                        (t.Cells[candidate_positions[c1][0].i, candidate_positions[c1][0].j].CandidatesNumber > 2 ||
                        t.Cells[candidate_positions[c1][1].i, candidate_positions[c1][1].j].CandidatesNumber > 2) &&
                        !IntPair.Equals(candidate_positions[c1][0], new IntPair(row, col)) &&
                        !IntPair.Equals(candidate_positions[c1][1], new IntPair(row, col)))
                    {
                        List<IntPair> rcc = new List<IntPair>();
                        List<int> rc = new List<int>();
                        List<IntPair> gcc = new List<IntPair>();
                        List<int> gc = new List<int>();

                        for (int k = 1; k <= t.M; ++k)
                        {
                            if (k == c1 || k == c2)
                            {
                                gcc.Add(candidate_positions[c1][0]);
                                gc.Add(k);
                            }
                            else if (t.Cells[candidate_positions[c1][0].i, candidate_positions[c1][0].j].IsCandidate(k))
                            {
                                rcc.Add(candidate_positions[c1][0]);
                                rc.Add(k);
                            }

                            if (k == c1 || k == c2)
                            {
                                gcc.Add(candidate_positions[c2][1]);
                                gc.Add(k);
                            }
                            else if (t.Cells[candidate_positions[c1][1].i, candidate_positions[c1][1].j].IsCandidate(k))
                            {
                                rcc.Add(candidate_positions[c1][1]);
                                rc.Add(k);
                            }
                        }

                        if (rcc.Count > 0)
                        {
                            HiddenPairPattern p = new HiddenPairPattern(0, gc, gcc, rc, rcc);
                            p.HouseType = RectangleTypes.Column;
                            if (AlgorithmManager.Instance.SolveState == SolveStates.RozsaSolve)
                            {
                                AlgorithmManager.Instance.ApplyPattern(p);
                            }
                            else
                            {
                                AlgorithmManager.Instance.AddPattern(p);
                            }
                        }
                    }
                }
            }
        }

        private void SearchHiddenPairInBox(int Xbox, int Ybox, int row, int col)
        {
            int[] candidate_numbers = new int[t.M + 1];
            IntPair[][] candidate_positions = new IntPair[t.M + 1][];
            for (int k = 0; k <= t.M; ++k)
            {
                candidate_positions[k] = new IntPair[2];
            }

            int start_X = Xbox * t.N;
            int start_Y = Ybox * t.N;

            for (int i = start_X; i < start_X + t.N; ++i)
            {
                for (int j = start_Y; j < start_Y + t.N; ++j)
                {
                    if (!t.Cells[i, j].IsData())
                    {
                        for (int c = 1; c <= t.M; ++c)
                        {
                            if (t.Cells[i, j].IsCandidate(c))
                            {
                                if (candidate_numbers[c] < 2)
                                {
                                    candidate_positions[c][candidate_numbers[c]] = new IntPair(i, j);
                                }
                                ++candidate_numbers[c];
                            }
                        }
                    }
                }
            }

            for (int c1 = 1; c1 < t.M; ++c1)
            {
                for (int c2 = c1 + 1; c2 <= t.M; ++c2)
                {
                    if (candidate_numbers[c1] == 2 && candidate_numbers[c2] == 2 &&
                        IntPair.Equals(candidate_positions[c1][0], candidate_positions[c2][0]) &&
                        IntPair.Equals(candidate_positions[c1][1], candidate_positions[c2][1]) &&
                        (t.Cells[candidate_positions[c1][0].i, candidate_positions[c1][0].j].CandidatesNumber > 2 ||
                        t.Cells[candidate_positions[c1][1].i, candidate_positions[c1][1].j].CandidatesNumber > 2) &&
                        !IntPair.Equals(candidate_positions[c1][0], new IntPair(row, col)) &&
                        !IntPair.Equals(candidate_positions[c1][1], new IntPair(row, col)))
                    {
                        List<IntPair> rcc = new List<IntPair>();
                        List<int> rc = new List<int>();
                        List<IntPair> gcc = new List<IntPair>();
                        List<int> gc = new List<int>();

                        for (int k = 1; k <= t.M; ++k)
                        {
                            if (k == c1 || k == c2)
                            {
                                gcc.Add(candidate_positions[c1][0]);
                                gc.Add(k);
                            }
                            else if (t.Cells[candidate_positions[c1][0].i, candidate_positions[c1][0].j].IsCandidate(k))
                            {
                                rcc.Add(candidate_positions[c1][0]);
                                rc.Add(k);
                            }

                            if (k == c1 || k == c2)
                            {
                                gcc.Add(candidate_positions[c2][1]);
                                gc.Add(k);
                            }
                            else if (t.Cells[candidate_positions[c1][1].i, candidate_positions[c1][1].j].IsCandidate(k))
                            {
                                rcc.Add(candidate_positions[c1][1]);
                                rc.Add(k);
                            }
                        }

                        HiddenPairPattern p = new HiddenPairPattern(0, gc, gcc, rc, rcc);
                        p.HouseType = RectangleTypes.Box;
                        if (AlgorithmManager.Instance.SolveState == SolveStates.RozsaSolve)
                        {
                            AlgorithmManager.Instance.ApplyPattern(p);
                        }
                        else
                        {
                            AlgorithmManager.Instance.AddPattern(p);
                        }
                    }
                }
            }
        }

        public override void solve(SudokuTable table)
        {
            t = table;
            if (!this.Enabled)
            {
                return;
            }

            ////////SOR
            for (int row = 0; row < t.M; ++row)
            {
                SearchHiddenPairInRow(row, -1);
            }

            ////////OSZLOP
            for (int col = 0; col < t.M; ++col)
            {
                SearchHiddenPairInColumn(-1, col);
            }

            ////////BLOKK
            for (int Xbox = 0; Xbox < t.N; ++Xbox)
            {
                for (int Ybox = 0; Ybox < t.N; ++Ybox)
                {
                    SearchHiddenPairInBox(Xbox, Ybox, -1, -1);
                }
            }
        }
    }
}
