using System;
using System.Collections.Generic;
using System.Text;

namespace Sudoku
{
    class Intersection : Algorithm
    {
        string globmessage = string.Empty;
        int[, ,] row_bricks;
        int[, ,] col_bricks;

        public Intersection(int tablesize)
        {
            name = "Intersection";

            int N = tablesize;
            int M = N * N;
            row_bricks = new int[M, M, N];
            col_bricks = new int[M, M, N];

            for (int i = 0; i < M; ++i)
            {
                for (int j = 0; j < N; ++j)
                {
                    for (int c = 0; c < M; ++c)
                    {
                        row_bricks[c, i, j] = N;
                        col_bricks[c, i, j] = N;
                    }
                }
            }
        }

        private void TestRowBrick(int i, int j, int c)
        {
            List<IntPair> rcc = new List<IntPair>();
            List<int> rc = new List<int>();
            List<IntPair> gcc = new List<IntPair>();
            List<int> gc = new List<int>();

            //sor
            //van-e a sorban tegla jelolt
            int count = 0;
            for (int k = 0; k < t.N; ++k)
            {
                if (row_bricks[c - 1, i, k] > 0)
                {
                    ++count;
                }
            }

            //ha csak 1 teglaban van meg a jelolt
            if (count == 1 && row_bricks[c - 1, i, j / t.N] > 1)
            {
                bool found = false;
                //vizsgalt blokk tobbi teglajaban levo megfelelo jeloltek kigyujtese
                for (int k = i / t.N * t.N; i / t.N == k / t.N; ++k)
                {
                    for (int r = j / t.N * t.N; j / t.N == r / t.N; ++r)
                    {
                        if (!t.Cells[k, r].IsData() && t.Cells[k, r].IsCandidate(c))
                        {
                            if (i != k)
                            {
                                rcc.Add(new IntPair(k, r));
                                rc.Add(c);
                                found = true;
                            }
                            else
                            {
                                gcc.Add(new IntPair(k, r));
                                gc.Add(c);
                            }
                        }
                    }
                }
                if (found && gc.Count > 1)
                {
                    IntersectionPattern p = new IntersectionPattern(c, gc, gcc, rc, rcc, t.N);
                    p.HouseType = RectangleTypes.Row;
                    p.TableSize = t.N;
                    if (AlgorithmManager.Instance.SolveState == SolveStates.RozsaSolve)
                    {
                        AlgorithmManager.Instance.ApplyPattern(p);
                    }
                    else
                    {
                        AlgorithmManager.Instance.AddPattern(p);
                    }
                }
            }
        }

        private void TestRowBoxBrick(int i, int j, int c)
        {
            List<IntPair> rcc = new List<IntPair>();
            List<int> rc = new List<int>();
            List<IntPair> gcc = new List<IntPair>();
            List<int> gc = new List<int>();

            if (i == 1 && j == 3 && c == 9)
            {
                int h = 5;
                ++h;
            }

            //blokk
            //van-e a blokkban tegla jelolt
            int count = 0;
            for (int k = (i / t.N) * t.N; k < (i / t.N) * t.N + t.N; ++k)
            {
                if (row_bricks[c - 1, k, j / t.N] > 0)
                {
                    ++count;
                }
            }

            //ha csak 1 teglaban van meg a jelolt
            if (count == 1 && row_bricks[c - 1, i, j / t.N] > 1)
            {
                bool found = false;
                //vizsgalt sor tobbi teglajaban levo megfelelo jeloltek kigyujtese
                for (int r = 0; r < t.M; ++r)
                {
                    if (!t.Cells[i, r].IsData() && t.Cells[i, r].IsCandidate(c))
                    {
                        if (r / t.N != j / t.N)
                        {
                            rcc.Add(new IntPair(i, r));
                            rc.Add(c);
                            found = true;
                        }
                        else
                        {
                            gcc.Add(new IntPair(i, r));
                            gc.Add(c);
                        }
                    }
                }
                if (found && gc.Count > 1)
                {
                    IntersectionPattern p = new IntersectionPattern(c, gc, gcc, rc, rcc, t.N);
                    p.HouseType = RectangleTypes.Row;
                    p.TableSize = t.N;
                    if (AlgorithmManager.Instance.SolveState == SolveStates.RozsaSolve)
                    {
                        AlgorithmManager.Instance.ApplyPattern(p);
                    }
                    else
                    {
                        AlgorithmManager.Instance.AddPattern(p);
                    }
                }
            }
        }

        private void TestColumnBrick(int j, int i, int c)
        {
            List<IntPair> rcc = new List<IntPair>();
            List<int> rc = new List<int>();
            List<IntPair> gcc = new List<IntPair>();
            List<int> gc = new List<int>();

            //oszlop
            //van-e az oszlopban tegla jelolt
            int count = 0;
            for (int k = 0; k < t.N; ++k)
            {
                if (col_bricks[c - 1, j, k] > 0)
                {
                    ++count;
                }
            }

            //ha csak 1 teglaban van meg a jelolt
            if (count == 1 && col_bricks[c - 1, j, i / t.N] > 1)
            {
                bool found = false;
                //vizsgalt blokk tobbi teglajaban levo megfelelo jeloltek kigyujtese
                for (int k = j / t.N * t.N; j / t.N == k / t.N; ++k)
                {
                    for (int r = i / t.N * t.N; i / t.N == r / t.N; ++r)
                    {
                        if (!t.Cells[r, k].IsData() && t.Cells[r, k].IsCandidate(c))
                        {
                            if (j != k)
                            {
                                rcc.Add(new IntPair(r, k));
                                rc.Add(c);
                                found = true;
                            }
                            else
                            {
                                gcc.Add(new IntPair(r, k));
                                gc.Add(c);
                            }
                        }
                    }
                }
                if (found && gc.Count > 1)
                {
                    IntersectionPattern p = new IntersectionPattern(c, gc, gcc, rc, rcc, t.N);
                    p.HouseType = RectangleTypes.Column;
                    p.TableSize = t.N;
                    if (AlgorithmManager.Instance.SolveState == SolveStates.RozsaSolve)
                    {
                        AlgorithmManager.Instance.ApplyPattern(p);
                    }
                    else
                    {
                        AlgorithmManager.Instance.AddPattern(p);
                    }
                }
            }
        }

        private void TestColumnBoxBrick(int i, int j, int c)
        {
            List<IntPair> rcc = new List<IntPair>();
            List<int> rc = new List<int>();
            List<IntPair> gcc = new List<IntPair>();
            List<int> gc = new List<int>();

            //blokk
            //van-e a blokkban tegla jelolt
            int count = 0;
            for (int k = (i / t.N) * t.N; k < (i / t.N) * t.N + t.N; ++k)
            {
                if (col_bricks[c - 1, k, j / t.N] > 0)
                {
                    ++count;
                }
            }

            //ha csak 1 teglaban van meg a jelolt
            if (count == 1 && col_bricks[c - 1, i, j / t.N] > 1)
            {
                bool found = false;
                //vizsgalt sor tobbi teglajaban levo megfelelo jeloltek kigyujtese
                for (int r = 0; r < t.M; ++r)
                {
                    if (!t.Cells[r, i].IsData() && t.Cells[r, i].IsCandidate(c))
                    {
                        if (r / t.N != j / t.N)
                        {
                            rcc.Add(new IntPair(r, i));
                            rc.Add(c);
                            found = true;
                        }
                        else
                        {
                            gcc.Add(new IntPair(r, i));
                            gc.Add(c);
                        }
                    }
                }
                if (found && gc.Count > 1)
                {
                    IntersectionPattern p = new IntersectionPattern(c, gc, gcc, rc, rcc, t.N);
                    p.HouseType = RectangleTypes.Column;
                    p.TableSize = t.N;
                    if (AlgorithmManager.Instance.SolveState == SolveStates.RozsaSolve)
                    {
                        AlgorithmManager.Instance.ApplyPattern(p);
                    }
                    else
                    {
                        AlgorithmManager.Instance.AddPattern(p);
                    }
                }
            }
        }

        public override string TestCell(SudokuTable table, IntPair redCell, IntPair greenCell, int redCand, int greenCand)
        {
            if (!Enabled) return "";
            t = table;

            //update the bricks
            if (row_bricks[redCand - 1, redCell.i, redCell.j / t.N] > 0) --row_bricks[redCand - 1, redCell.i, redCell.j / t.N];
            if (col_bricks[redCand - 1, redCell.j, redCell.i / t.N] > 0) --col_bricks[redCand - 1, redCell.j, redCell.i / t.N];

            //test the changed bricks
            for (int k = 0; k < t.N; ++k)
            {
                if (row_bricks[redCand - 1, redCell.i, k] > 1 && k != redCell.j / t.N)
                {
                    TestRowBrick(redCell.i, k * t.N, redCand);
                }
                if (col_bricks[redCand - 1, redCell.j, k] > 1 && k != redCell.j / t.N)
                {
                    //TestColumnBrick(k * t.N, redCell.j, redCand);
                    TestColumnBoxBrick(redCell.j, k * t.N, redCand);
                }
            }

            for (int k = (redCell.i / t.N) * t.N; k < (redCell.i / t.N) * t.N + t.N; ++k)
            {
                if (col_bricks[redCand - 1, k, redCell.j / t.N] > 1 && k != redCell.i)
                {
                    TestColumnBoxBrick(k, redCell.j, redCand);
                }
            }

            for (int k = (redCell.j / t.N) * t.N; k < (redCell.j / t.N) * t.N + t.N; ++k)
            {
                if (row_bricks[redCand - 1, k, redCell.i / t.N] > 1 && k != redCell.j)
                {
                    //TestRowBoxBrick(redCell.i, k, redCand);
                    TestRowBoxBrick(k, redCell.i, redCand);
                }
            }

            return "";
        }

        public override void solve(SudokuTable table)
        {
            t = table;
            if (!this.Enabled)
            {
                return;
            }

            row_bricks = new int[t.M, t.M, t.N]; 
            col_bricks = new int[t.M, t.M, t.N];

            for (int i = 0; i < t.M; ++i)
            {
                for (int j = 0; j < t.N; ++j)
                {
                    for (int c = 0; c < t.M; ++c)
                    {
                        row_bricks[c, i, j] = 0;
                        col_bricks[c, i, j] = 0;
                    }
                }
            }

            for (int i = 0; i < t.M; ++i)
            {
                for (int j = 0; j < t.M; ++j)
                {
                    for (int c = 1; c <= t.M; ++c)
                    {
                        if (!t.Cells[i, j].IsData() && t.Cells[i, j].IsCandidate(c))
                        {
                            ++row_bricks[c - 1, i, j / t.N];
                        }
                        if (!t.Cells[j, i].IsData() && t.Cells[j, i].IsCandidate(c))
                        {
                            ++col_bricks[c - 1, i, j / t.N];
                        }
                    }
                }
            }

            for (int i = 0; i < t.M; ++i)
            {
                for (int j = 0; j < t.M; j += t.N)
                {
                    for (int c = 1; c <= t.M; ++c)
                    {
                        if (row_bricks[c - 1, i, j / t.N] > 1)
                        {
                            TestRowBrick(i, j, c);
                        }
                        if (row_bricks[c - 1, i, j / t.N] > 1)
                        {
                            TestRowBoxBrick(i, j, c);
                        }
                    }
                }
            }

            for (int i = 0; i < t.M; i += t.N)
            {
                for (int j = 0; j < t.M; ++j)
                {
                    for (int c = 1; c <= t.M; ++c)
                    {
                        if (col_bricks[c - 1, j, i / t.N] > 1)
                        {
                            TestColumnBrick(j, i, c);
                        }
                        if (col_bricks[c - 1, j, i / t.N] > 1)
                        {
                            TestColumnBoxBrick(j, i, c);
                        }
                    }
                }
            }
        }
    }
}
