﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Sudoku
{
    class NakedQuad : Algorithm
    {

        public NakedQuad()
        {
            name = "Naked Quad";
        }

        string globmessage = string.Empty;

        public override string TestCell(SudokuTable table, IntPair redCell, IntPair greenCell, int redCand, int greenCand)
        {
            if (!Enabled) return "";

            t = table;
            if (t.Cells[redCell.i, redCell.j].CandidatesNumber >= 2 && t.Cells[redCell.i, redCell.j].CandidatesNumber <= 3)
            {
                TestCellInRow(redCell.i);
                TestCellInColumn(redCell.j);
                TestCellInBox(redCell.i / t.N, redCell.j / t.N);
            }

            return "";
        }

        private void TestCellInRow(int row)
        {
            List<IntPair> cells = new List<IntPair>();
            for (int k = 0; k < t.M; ++k)
            {
                if (!t.Cells[row, k].IsData() && t.Cells[row, k].CandidatesNumber >= 2 && t.Cells[row, k].CandidatesNumber <= 4)
                {
                    cells.Add(new IntPair(row, k));
                }
            }

            for (int p1 = 0; p1 < cells.Count; ++p1)
            {
                for (int p2 = p1 + 1; p2 < cells.Count; ++p2)
                {
                    for (int p3 = p2 + 1; p3 < cells.Count; ++p3)
                    {
                        for (int p4 = p3 + 1; p4 < cells.Count; ++p4)
                        {
                            int sum = 0;
                            bool[] test = new bool[t.M + 1];
                            List<IntPair> candidatecells = new List<IntPair>();

                            for (int k = 1; k <= t.M; ++k)
                            {
                                if (t.Cells[cells[p1].i, cells[p1].j].IsCandidate(k) || t.Cells[cells[p2].i, cells[p2].j].IsCandidate(k)
                                    || t.Cells[cells[p3].i, cells[p3].j].IsCandidate(k) || t.Cells[cells[p4].i, cells[p4].j].IsCandidate(k))
                                {
                                    if (t.Cells[cells[p1].i, cells[p1].j].IsCandidate(k) && !candidatecells.Contains(cells[p1])) candidatecells.Add(cells[p1]);
                                    if (t.Cells[cells[p2].i, cells[p2].j].IsCandidate(k) && !candidatecells.Contains(cells[p2])) candidatecells.Add(cells[p2]);
                                    if (t.Cells[cells[p3].i, cells[p3].j].IsCandidate(k) && !candidatecells.Contains(cells[p3])) candidatecells.Add(cells[p3]);
                                    if (t.Cells[cells[p4].i, cells[p4].j].IsCandidate(k) && !candidatecells.Contains(cells[p4])) candidatecells.Add(cells[p4]);
                                    test[k] = true;
                                    ++sum;
                                }
                            }

                            if (sum == 4 && candidatecells.Count == 4)
                            {
                                CreatePatternRow(test, row, cells[p1].j, cells[p2].j, cells[p3].j, cells[p4].j);
                            }
                        }
                    }
                }
            }
        }

        private void TestCellInColumn(int col)
        {
            List<IntPair> cells = new List<IntPair>();
            for (int i = 0; i < t.M; ++i)
            {
                if (!t.Cells[i, col].IsData() && t.Cells[i, col].CandidatesNumber >= 2 && t.Cells[i, col].CandidatesNumber <= 4)
                {
                    cells.Add(new IntPair(i, col));
                }
            }

            for (int p1 = 0; p1 < cells.Count; ++p1)
            {
                for (int p2 = p1 + 1; p2 < cells.Count; ++p2)
                {
                    for (int p3 = p2 + 1; p3 < cells.Count; ++p3)
                    {
                        for (int p4 = p3 + 1; p4 < cells.Count; ++p4)
                        {
                            int sum = 0;
                            bool[] test = new bool[t.M + 1];
                            List<IntPair> candidatecells = new List<IntPair>();

                            for (int k = 1; k <= t.M; ++k)
                            {
                                if (t.Cells[cells[p1].i, cells[p1].j].IsCandidate(k) || t.Cells[cells[p2].i, cells[p2].j].IsCandidate(k)
                                    || t.Cells[cells[p3].i, cells[p3].j].IsCandidate(k) || t.Cells[cells[p4].i, cells[p4].j].IsCandidate(k))
                                {
                                    if (t.Cells[cells[p1].i, cells[p1].j].IsCandidate(k) && !candidatecells.Contains(cells[p1])) candidatecells.Add(cells[p1]);
                                    if (t.Cells[cells[p2].i, cells[p2].j].IsCandidate(k) && !candidatecells.Contains(cells[p2])) candidatecells.Add(cells[p2]);
                                    if (t.Cells[cells[p3].i, cells[p3].j].IsCandidate(k) && !candidatecells.Contains(cells[p3])) candidatecells.Add(cells[p3]);
                                    if (t.Cells[cells[p4].i, cells[p4].j].IsCandidate(k) && !candidatecells.Contains(cells[p4])) candidatecells.Add(cells[p4]);
                                    test[k] = true;
                                    ++sum;
                                }
                            }

                            if (sum == 4 && candidatecells.Count == 4)
                            {
                                CreatePatternColumn(test, col, cells[p1].i, cells[p2].i, cells[p3].i, cells[p4].i);
                            }
                        }
                    }
                }
            }
        }

        private void TestCellInBox(int bi, int bj)
        {
            //Azok a cellak, amik szerepelhetnek tiszta negyes mintaban
            //Tovabbiakban kenyelmesebb ezt vizsgalni
            List<IntPair> cells = new List<IntPair>();
            for (int i = bi * t.N; i / t.N == bi; ++i)
            {
                for (int j = bj * t.N; j / t.N == bj; ++j)
                {
                    if (!t.Cells[i, j].IsData() && t.Cells[i, j].CandidatesNumber >= 2 && t.Cells[i, j].CandidatesNumber <= 4)
                    {
                        cells.Add(new IntPair(i, j));
                    }
                }
            }

            for (int p1 = 0; p1 < cells.Count; ++p1)
            {
                for (int p2 = p1 + 1; p2 < cells.Count; ++p2)
                {
                    for (int p3 = p2 + 1; p3 < cells.Count; ++p3)
                    {
                        for (int p4 = p3 + 1; p4 < cells.Count; ++p4)
                        {
                            int sum = 0;
                            bool[] test = new bool[t.M + 1];
                            List<IntPair> candidatecells = new List<IntPair>();

                            for (int i = 1; i <= t.M; ++i)
                            {
                                if (t.Cells[cells[p1].i, cells[p1].j].IsCandidate(i) || t.Cells[cells[p2].i, cells[p2].j].IsCandidate(i) ||
                                    t.Cells[cells[p3].i, cells[p3].j].IsCandidate(i) || t.Cells[cells[p4].i, cells[p4].j].IsCandidate(i))
                                {
                                    if (t.Cells[cells[p1].i, cells[p1].j].IsCandidate(i) && !candidatecells.Contains(cells[p1])) candidatecells.Add(cells[p1]);
                                    if (t.Cells[cells[p2].i, cells[p2].j].IsCandidate(i) && !candidatecells.Contains(cells[p2])) candidatecells.Add(cells[p2]);
                                    if (t.Cells[cells[p3].i, cells[p3].j].IsCandidate(i) && !candidatecells.Contains(cells[p3])) candidatecells.Add(cells[p3]);
                                    if (t.Cells[cells[p4].i, cells[p4].j].IsCandidate(i) && !candidatecells.Contains(cells[p4])) candidatecells.Add(cells[p4]);
                                    test[i] = true;
                                    ++sum;
                                }
                            }

                            if (sum == 4 && candidatecells.Count == 4)
                            {
                                CreatePatternBlock(test, cells[p1].i, cells[p1].j, cells[p2].i, cells[p2].j, cells[p3].i, cells[p3].j, cells[p4].i, cells[p4].j);
                            }
                        }
                    }
                }
            }
        }

        public override void solve(SudokuTable table)
        {
            if (!this.Enabled)
            {
                return;
            }
            t = table;

            ////////SOR
            for (int r = 0; r < t.M; ++r)
            {
                TestCellInRow(r);
            }

            ////////OSZLOP
            for (int c = 0; c < t.M; ++c)
            {
                TestCellInColumn(c);
            }

            ////////BLOKK
            //vegig a blokkokon
            for (int bi = 0; bi < t.N; ++bi)
            {
                for (int bj = 0; bj < t.N; ++bj)
                {
                    TestCellInBox(bi, bj);
                }
            }
        }

        private void CreatePatternRow(bool[] test, int r, int c1, int c2, int c3, int c4)
        {
            List<IntPair> q = new List<IntPair>();
            List<int> cq = new List<int>();
            int[] cand = new int[4];

            //aktuális blokk bal felsõ indexe
            int bx = (r / t.N) * t.N;
            int by = (c1 / t.N) * t.N;

            //jelöltek kigyûjtése
            int i = 0;
            for (int c = 1; c <= t.M; c++)
            {
                if (test[c])
                {
                    cand[i++] = c;
                }
            }

            int sum = 0; //ezzel a találattal hány helyrõl húzhatok

            //végig a soron
            for (int l = 0; l < t.M; l++)
            {
                //ha húzható, tehát i, l nem eleme match-nek 
                if (!(l == c1 || l == c2 || l == c3 || l == c4))
                {
                    //minden jelölt
                    for (int jj = 0; jj < 4; jj++)
                    {
                        //ha jelölt és nincs adat, akkor húzásra kijelölés
                        if (t.Cells[r, l].IsCandidate(cand[jj]) && !t.Cells[r, l].IsData())
                        {
                            sum++;
                            q.Add(new IntPair(r, l)); //honnan
                            cq.Add(cand[jj]); //mit
                        }
                    }
                }
            }
            //ha tudtam húzni
            if (sum != 0)
            {
                List<IntPair> gcc = new List<IntPair>();
                List<int> gc = new List<int>();
                for (i = 0; i < 4; ++i)
                {
                    gcc.Add(new IntPair(r, c1));
                    gc.Add(cand[i]);
                    gcc.Add(new IntPair(r, c2));
                    gc.Add(cand[i]);
                    gcc.Add(new IntPair(r, c3));
                    gc.Add(cand[i]);
                    gcc.Add(new IntPair(r, c4));
                    gc.Add(cand[i]);
                }

                NakedQuadPattern p = new NakedQuadPattern(0, gc, gcc, cq, q);
                p.HouseType = RectangleTypes.Row;
                if (AlgorithmManager.Instance.SolveState == SolveStates.RozsaSolve)
                {
                    AlgorithmManager.Instance.ApplyPattern(p);
                }
                else
                {
                    AlgorithmManager.Instance.AddPattern(p);
                }
            }
        }

        private void CreatePatternColumn(bool[] test, int c, int c1, int c2, int c3, int c4)
        {
            List<IntPair> q = new List<IntPair>();
            List<int> cq = new List<int>();
            int[] cand = new int[4];

            //aktuális blokk bal felsõ indexe
            int bx = (c / t.N) * t.N;
            int by = (c1 / t.N) * t.N;

            //jelöltek kigyûjtése
            int i = 0;
            for (int p = 1; p <= t.M; p++)
            {
                if (test[p])
                {
                    cand[i++] = p;
                }
            }

            int sum = 0; //ezzel a találattal hány helyrõl húzhatok

            //végig az oszlopon
            for (int l = 0; l < t.M; l++)
            {
                //ha húzható, tehát l, j nem eleme match-nek 
                if (!(l == c1 || l == c2 || l == c3 || l == c4))
                {
                    //minden jelölt
                    for (int jj = 0; jj < 4; jj++)
                    {
                        //ha jelölt és nincs adat, akkor húzásra kijelölés
                        if (t.Cells[l, c].IsCandidate(cand[jj]) && !t.Cells[l, c].IsData())
                        {
                            sum++;
                            q.Add(new IntPair(l, c)); //honnan
                            cq.Add(cand[jj]); //mit
                        }
                    }
                }
            }
            //ha tudtam húzni
            if (sum != 0)
            {
                List<IntPair> gcc = new List<IntPair>();
                List<int> gc = new List<int>();
                for (i = 0; i < 4; ++i)
                {
                    gcc.Add(new IntPair(c1, c));
                    gc.Add(cand[i]);
                    gcc.Add(new IntPair(c2, c));
                    gc.Add(cand[i]);
                    gcc.Add(new IntPair(c3, c));
                    gc.Add(cand[i]);
                    gcc.Add(new IntPair(c4, c));
                    gc.Add(cand[i]);
                }

                NakedQuadPattern p = new NakedQuadPattern(0, gc, gcc, cq, q);
                p.HouseType = RectangleTypes.Column;
                if (AlgorithmManager.Instance.SolveState == SolveStates.RozsaSolve)
                {
                    AlgorithmManager.Instance.ApplyPattern(p);
                }
                else
                {
                    AlgorithmManager.Instance.AddPattern(p);
                }
            }
        }

        private void CreatePatternBlock(bool[] test, int ci1, int cj1, int ci2, int cj2, int ci3, int cj3, int ci4, int cj4)
        {
            List<IntPair> q = new List<IntPair>();
            List<int> cq = new List<int>();
            int[] cand = new int[4];

            //aktuális blokk bal felsõ indexe
            int bx = (ci1 / t.N) * t.N;
            int by = (cj1 / t.N) * t.N;

            //jelöltek kigyûjtése
            int i = 0;
            for (int c = 1; c <= t.M; c++)
            {
                if (test[c])
                {
                    cand[i++] = c;
                }
            }

            int sum = 0;
            //DeleteInBlock(ref match, bx, by, ref sum);

            for (int kk = bx; kk < bx + t.N; kk++)
            {
                for (int ll = by; ll < by + t.N; ll++)
                {
                    //ha húzható, tehát kk,ll nem eleme match-nek 
                    if (!((kk == ci1 && ll == cj1) || (kk == ci2 && ll == cj2) || 
                        (kk == ci3 && ll == cj3) || (kk == ci4 && ll == cj4)))
                    {
                        //minden jelölt
                        for (int jj = 0; jj < 4; jj++)
                        {
                            //ha jelölt és nincs adat, akkor húzásra kijelölés
                            if (t.Cells[kk, ll].IsCandidate(cand[jj]) && !t.Cells[kk, ll].IsData())
                            {
                                sum++;
                                q.Add(new IntPair(kk, ll)); //honnan
                                cq.Add(cand[jj]); //mit
                            }
                        }
                    }
                }
            }

            //ha tudtam húzni
            if (sum != 0)
            {
                List<IntPair> gcc = new List<IntPair>();
                List<int> gc = new List<int>();
                for (i = 0; i < 4; ++i)
                {
                    gcc.Add(new IntPair(ci1, cj1));
                    gc.Add(cand[i]);
                    gcc.Add(new IntPair(ci2, cj2));
                    gc.Add(cand[i]);
                    gcc.Add(new IntPair(ci3, cj3));
                    gc.Add(cand[i]);
                    gcc.Add(new IntPair(ci4, cj4));
                    gc.Add(cand[i]);
                }

                NakedQuadPattern p = new NakedQuadPattern(0, gc, gcc, cq, q);
                p.HouseType = RectangleTypes.Box;
                if (AlgorithmManager.Instance.SolveState == SolveStates.RozsaSolve)
                {
                    AlgorithmManager.Instance.ApplyPattern(p);
                }
                else
                {
                    AlgorithmManager.Instance.AddPattern(p);
                }
            }

        }
    }
}
