using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Sudoku
{
    public partial class GeneratorForm : Form
    {
        bool foundtable = false;

        public bool Foundtable
        {
            get { return foundtable; }
        }

        SudokuGenerator sg;

        internal SudokuGenerator Generator
        {
            get { return sg; }
        }
        bool timeout = false;
        int maxtry;
        int state = 0;

        public GeneratorForm(int size, int maxtry)
        {
            InitializeComponent();
            this.maxtry = maxtry;
            sg = new SudokuGenerator(size, maxtry);
            timer1.Interval = size * 2000;
            progressBar1.Maximum = maxtry;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (backgroundWorker1.IsBusy)
            {
                backgroundWorker1.CancelAsync();
            }
            this.Close();
        }

        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            sg.Generate(backgroundWorker1);
            timer1.Start();
        }

        private void backgroundWorker1_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            if (e.ProgressPercentage == -1)
            {
                label1.Text = "Tbla egyszerstse...";
                label2.Text = string.Empty;
                timer1.Stop();
            }
            else
            {
                progressBar1.Value = e.ProgressPercentage;
                state = progressBar1.Value;
                label2.Text = e.ProgressPercentage.ToString() + @"/" + maxtry.ToString();
            }
            label4.Text = ((int)e.UserState).ToString();
            
        }
        private void backgroundWorker1_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            if (timeout)
            {
                backgroundWorker1.RunWorkerAsync();
                timeout = false;
                return;
            }
            foundtable = sg.Foundtable;
            if (foundtable)
            {
                Close();
            }
            else
            {
                button1.Text = "Nincs tallat";
            }
        }

        private void GeneratorForm_Load(object sender, EventArgs e)
        {
            backgroundWorker1.RunWorkerAsync();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (state == progressBar1.Value && backgroundWorker1.IsBusy)
            {
                timer1.Stop();
                backgroundWorker1.CancelAsync();            
                state = 0;
                timeout = true;
            }
        }
    }
}