﻿using System;
using System.Collections.Generic;
using System.Text;


namespace Sudoku
{
    public class CrookPattern : Pattern
    {
        /// <summary>
        /// A minta konstruktora
        /// </summary>
        /// <param name="cv">Beirando jelolt erteke (0 ha nincs)</param>
        /// <param name="gc">Zold jeloltek ertekei</param>
        /// <param name="gcc">Zold jeloltek</param>
        /// <param name="rc">Kihuzando jeloltek ertekei</param>
        /// <param name="rcc">Kihuzhato jeloltek mezoi</param>
        public CrookPattern(int cv, List<int> gc, List<IntPair> gcc, List<int> rc, List<IntPair> rcc)
        {
            this.algorithmIndex = 10;
            this.candidateValue = cv;
            this.greenCandidates = gc;
            this.greenCandidateCells = gcc;
            this.redCandidates = rc;
            this.redCandidateCells = rcc;
            this.text = "r" + (greenCandidateCells[0].i + 1).ToString() + "c" + (greenCandidateCells[0].j + 1).ToString() + "->" + SudokuCell.ConvertCellDataToString(greenCandidates[0], AlgorithmManager.Instance.Table.M) + " (Crook)";
        }

        protected override string getReportEntry(SudokuTable t)
        {
            string message = "r" + (greenCandidateCells[0].i + 1).ToString() +
                "c" + (greenCandidateCells[0].j + 1).ToString() + "=" +
                SudokuCell.ConvertCellDataToString(candidateValue, t.M) + " (Crook)";

            return message;
        }

        public override void PaintPattern(SudokuTable t)
        {
            for (int i = 0; i < t.M; ++i)
            {
                for (int j = 0; j < t.M; ++j)
                {
                    if (greenCandidateCells[0].i == i && greenCandidateCells[0].j == j)
                    {
                        t.Cells[i, j].BackGroundColor = 5;
                    }
                    else if (greenCandidateCells[0].i == i || greenCandidateCells[0].j == j ||
                        greenCandidateCells[0].i / t.N == i / t.N && greenCandidateCells[0].j / t.N == j / t.N)
                    {
                        t.Cells[i, j].BackGroundColor = 4;
                    }
                    else t.Cells[i, j].BackGroundColor = 3;

                    for (int c = 1; c <= t.M; ++c)
                    {
                        t.Cells[i, j].SetColor(c, 0);
                    }
                }
            } 
            
            for (int i = 0; i < redCandidateCells.Count; ++i)
            {
                t.Cells[redCandidateCells[i].i, redCandidateCells[i].j].SetColor(redCandidates[i], 2);
            }

            for (int i = 0; i < greenCandidateCells.Count; ++i)
            {
                t.Cells[greenCandidateCells[i].i, greenCandidateCells[i].j].SetColor(greenCandidates[i], 1);
            }
        }
    }
}
