﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Sudoku
{
    public class NakedErrorPattern : Pattern
    {
        /// <summary>
        /// A minta konstruktora
        /// </summary>
        /// <param name="gcc">Zold jeloltek</param>
        /// <param name="rc">Kihuzando jeloltek ertekei</param>
        /// <param name="rcc">Kihuzhato jeloltek mezoi</param>
        public NakedErrorPattern(IntPair cell)
        {
            this.algorithmIndex = 9;
            this.candidateValue = 0;
            this.greenCandidates = new List<int>();
            this.greenCandidateCells = new List<IntPair>();
            this.greenCandidateCells.Add(cell);
            this.redCandidates = new List<int>();
            this.redCandidateCells = new List<IntPair>();

            this.text = "r" + (cell.i + 1).ToString() + "c" + (cell.j + 1).ToString() + 
                " cellában nem maradt beírható jelölt.";
        }

        protected override string getReportEntry(SudokuTable t)
        {
            string message = "\\highlight1 r" + (greenCandidateCells[0].i + 1).ToString() + "c" + (greenCandidateCells[0].j + 1).ToString() +
                " cell\\'e1ban nem maradt kih\\'fazhat\\'f3 jel\\'f6lt. \\highlight0";
            return message;
        }

        public override void PaintPattern(SudokuTable t)
        {
            for (int i = 0; i < t.M; ++i)
            {
                for (int j = 0; j < t.M; ++j)
                {
                    t.Cells[i, j].BackGroundColor = 3;
                    for (int c = 1; c <= t.M; ++c)
                    {
                        t.Cells[i, j].SetColor(c, 0);
                    }
                }
            }
            t.Cells[greenCandidateCells[0].i, greenCandidateCells[0].j].BackGroundColor = 2;

            bool[] cands = new bool[t.M];
            for (int k = 0; k < t.M; ++k) cands[k] = false;

            for (int row = 0; row < t.M; ++row)
            {
                if (t.Cells[row, greenCandidateCells[0].j].IsData() && cands[t.Cells[row, greenCandidateCells[0].j].Data - 1] == false)
                {
                    t.Cells[row, greenCandidateCells[0].j].BackGroundColor = 4;
                    cands[t.Cells[row, greenCandidateCells[0].j].Data - 1] = true;
                }
            }

            for (int col = 0; col < t.M; ++col)
            {
                if (t.Cells[greenCandidateCells[0].i, col].IsData() && cands[t.Cells[greenCandidateCells[0].i, col].Data - 1] == false)
                {
                    t.Cells[greenCandidateCells[0].i, col].BackGroundColor = 4;
                    cands[t.Cells[greenCandidateCells[0].i, col].Data - 1] = true;
                }
            }

            for (int x = greenCandidateCells[0].i / t.N * t.N; greenCandidateCells[0].i / t.N == x / t.N; ++x)
            {
                for (int y = greenCandidateCells[0].j / t.N * t.N; greenCandidateCells[0].j / t.N == y / t.N; ++y)
                {
                    if (t.Cells[x, y].IsData() && cands[t.Cells[x, y].Data - 1] == false)
                    {
                        t.Cells[x, y].BackGroundColor = 4;
                        cands[t.Cells[x, y].Data - 1] = true;
                    }
                }
            }
        }
    }
}
