using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.IO;

namespace Sudoku
{
    class SudokuGenerator
    {
        SudokuTable t;

        public SudokuTable Table
        {
            get { return t; }
        }

        int maxtry;

        public int Maxtry
        {
            get { return maxtry; }
        }


        bool foundtable = false;

        public bool Foundtable
        {
            get { return foundtable; }
        }

        int size;//generland tbla mrete (n)

        DancingLinks dlx;

        Random r;

        Queue<IntPair> q;//az aktulis adatok

        public SudokuGenerator() : this(3,100)
        { }

        public SudokuGenerator(int size, int maxtry)
        {
            this.maxtry = maxtry;
            this.size = size;
            t = new SudokuTable(this.size);
            dlx = new DancingLinks();
            r = new Random();
            q = new Queue<IntPair>();
        }

        public void Init()
        {
            q.Clear();
        }
        
        //egyszersts: az elemeket egyesvel elhagyva j marad-e a tbla
        void Reduce(System.ComponentModel.BackgroundWorker worker)
        {
            int c;
            //bool red = false;
            while (q.Count != 0)
            {
                if (worker.CancellationPending)
                {
                    break;
                }
                //kiveszek egy elemet
                IntPair p = q.Dequeue();
                worker.ReportProgress(-1, t.DataInTable);
                //az elem helyn trlk a tblbl
                c = t.Cells[p.i, p.j].Data;
                t.setCellData(p.i, p.j, 0);
                t.AddCandidateToThreeHouse(p.i, p.j, c);
                dlx.Table = t;
                dlx.Run(worker);
                //ha gy mr nem j
                if (dlx.Count != 1)
                {
                    //visszalltom
                    //q.Enqueue(new IntPair(i, j));
                    //red = false;
                    t.setCellData(p.i, p.j, c);
                    t.DeleteCandidateFromThreeHouse(p.i, p.j, c);
                }
            }
        }

        public void Generate(System.ComponentModel.BackgroundWorker worker)
        {
                t = new SudokuTable(t.N);
                q.Clear();
                int sizeMax = 0; //max adat a tblban
                switch (t.N)
                {
                    case 2:
                        sizeMax = 4;
                        break;
                    case 3:
                        sizeMax = 25;
                        break;
                    case 4:
                        sizeMax = 120;
                        break;
                    case 5:
                        sizeMax = 360;
                        break;
                }
                int row = 0, col = 0, d = 1;
                int ciklus = 0;
                string message = string.Empty;
                IntPair p;
                int dd;
                //indul mezk
            //    try
            //    {
            //    while (dlx.Count != 0)
            //    {
            //        t = new SudokuTable(t.N);
            //        for (int i = 0; i < 2 * t.M/*sizeMax * 2 / 3*/; i++)
            //        {
            //            AddNewRandomData(ref row, ref col, ref d);
            //        }
            //        dlx.Table = t;
            //        dlx.Run(worker);
            //    }     }
            //catch (Exception ex) { 
            //    System.Windows.Forms.MessageBox.Show(d.ToString()); }
       //try{
            //amg nem tallt j tblt, vagy nem prblkozott eleget
                while (dlx.Count != 1 && ciklus < maxtry)
                {
                    ciklus++;
                    worker.ReportProgress(ciklus, t.DataInTable);
                    if (t.DataInTable >= sizeMax)
                    {
                        p = q.Dequeue();
                        dd = t.getCellData(p.i, p.j);
                        t.setCellData(p.i, p.j, 0);
                        t.AddCandidateToThreeHouse(p.i, p.j, dd);
                    }
                    AddNewRandomData(ref row, ref col, ref d);
                    dlx.Table = t;
                    dlx.Run(worker);
                    if (worker.CancellationPending)
                    {
                        break;
                    }
                    //ha rossz a tbla az j elemmel
                    if (dlx.Count == 0)
                    {
                        //visszallts
                        t.setCellData(row, col, 0);
                        t.AddCandidateToThreeHouse(row, col, d);
                    }
                    else
                    {
                        //bekerl a sorba
                        q.Enqueue(new IntPair(row, col));
                    }

                }
                if (dlx.Count == 1)
                {
                    Reduce(worker);
                    foundtable = true;
                }
                else
                {
                    foundtable = false;
                }
            //}
            ////catch (Exception ex) {
            ////    System.Windows.Forms.MessageBox.Show(d.ToString()); }
        }

        private void AddNewRandomData(ref int row, ref int col, ref int d)
        {
            row = r.Next(t.M);
            col = r.Next(t.M);
            d = r.Next(t.M) + 1;
            while (t.Cells[row, col].IsData() || !t.Cells[row, col].IsCandidate(d))
            {
                row = r.Next(t.M);
                col = r.Next(t.M);
                d = r.Next(t.M) + 1;
            }
            t.setCellData(row, col, d);
            if (!t.DeleteCandidateFromThreeHouse(row, col, d))
            {
                //ha a trls utn 0 jelltes cella van, visszallts
                t.setCellData(row, col, 0);
                t.AddCandidateToThreeHouse(row, col, d);
                AddNewRandomData(ref row, ref col, ref d);
            }
        }
    }
}
